000010 IDENTIFICATION DIVISION.
000020*@M              MAIN
000030 PROGRAM-ID. SMAIL.
000040 DATE-COMPILED.
000050* ------------------------: Simple mail demo program
000060*                         : Used to demonstrate GUI-ScreenIO's
000070*                         : mail  API calls.
000080*                         :
000090*                         : Designed to be linked into a stand-
000100*                         : alone .EXE.
000110*                         : It provides a user entery
000120*                         : screen for message text etc and
000130*                         : a configuration screen for settings
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 ENVIRONMENT DIVISION.
000160* 030817ja-19 Add low-value at end of each transmission
000170* 030816ja-18 Add ready checks before each buffer read
000180* 030815ja-1 First draft.
000190*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000200 CONFIGURATION SECTION.
000210 SOURCE-COMPUTER. IBM-PC.
000220 OBJECT-COMPUTER. IBM-PC.
000230*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000240 DATA DIVISION.
000250*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000260 WORKING-STORAGE SECTION.
000270 01  V--VERSION-LEVEL                 PIC 9(3) VALUE 14.
000280* -====-
000290*                         : Copy the main panel
000300         COPY SMAILER.
000310*                         : Copy the base panel and pop-up
000320         COPY SMAIL001.
000330         COPY SMAIL002.
000340*                         : Copy values for our API calls
000350         COPY WIN32API.
000360         COPY REGISTRY.
000370         COPY MAILAPI.
000380*
000390*                         : Used to split up email addresses
000400 01  WS-USER-EMAIL-NAME               PIC X(100).
000410 01  WS-USER-EMAIL-DOMAIN             PIC X(100).
000420 01  WS-USER-EMAIL-AT-SIGN            PIC X.
000430*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000440 PROCEDURE DIVISION.
000450*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000460*
000470*                         : First we make our initialization call.
000480     PERFORM 0103-MANAGE-CONTAINER.
000490     PERFORM 0105-FETCH-SETTINGS.
000500*
000510* ------------------------: Display the test panel.
000520*
000530     PERFORM WITH TEST AFTER
000540           UNTIL SMAIL001-EVENT-CLOSE-WINDOW
000550           OR SMAIL001-EVENT-CLOSE-AND-STOP
000560           OR SMAIL001-CANCEL
000570*
000580       PERFORM 0101-DISPLAY-PANEL
000590*
000600       EVALUATE TRUE
000610         WHEN SMAIL001-SETTINGS
000620           PERFORM 0104-SETTINGS-ROUTINE
000630         WHEN SMAIL001-SEND
000640           IF SM-PORT NUMERIC AND SM-PORT > 0 AND
000650                 SM-YOUR-EMAIL > SPACE AND
000660                 SM-SMTP-SERVER > SPACE AND
000670                 WS-USER-EMAIL-AT-SIGN = '@' AND
000680                 WS-USER-EMAIL-NAME > SPACE AND
000690                 WS-USER-EMAIL-DOMAIN > SPACE
000700*
000710             IF SM-TO > SPACE AND
000720                   SM-TEXT > SPACE AND
000730                   SM-SUBJECT > SPACE
000740               PERFORM 0107-SEND-MAIL
000750             ELSE
000760               MOVE 'Missing Address, subject, or text' TO
000770                   SMAIL001-MESSAGE-TEXT
000780               SET SMAIL001-MB-STOP-ICON
000790                   SMAIL001-MB-BTN-OK TO TRUE
000800             END-IF
000810           ELSE
000820             MOVE 'INVALID SETTINGS' TO SMAIL002-MESSAGE-TEXT
000830             SET SMAIL002-MESSAGE-IN-MESSAGEBOX TO TRUE
000840             PERFORM 0104-SETTINGS-ROUTINE
000850           END-IF
000860*
000870       END-EVALUATE
000880*
000890     END-PERFORM.
000900*
000910* ------------------------: Close the main before doing a STOP RUN
000920*
000930     SET SMAILER-DO-CLOSE TO TRUE.
000940     PERFORM 0103-MANAGE-CONTAINER.
000950*
000960     STOP RUN.
000970*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000980 0100-GS-UTILITY SECTION.
000990* -====-
001000 0101-DISPLAY-PANEL.
001010     CALL 'GS' USING SMAIL001-1
001020                     SMAIL001-2
001030                     SMAIL001-3
001040                     SMAIL001-4.
001050*
001060 0102-API-CALL.
001070     MOVE 'MailSettings' TO REGISTRY-SUBKEY.
001080     CALL 'GSWINAPI' USING WIN32API-PARMS
001090                           REGISTRY-PARMS
001100                           WIN32API-B
001110                           WIN32API-C
001120                           WIN32API-D
001130                           WIN32API-E
001140                           WIN32API-F.
001150*
001160 0103-MANAGE-CONTAINER.
001170*                         : This section is used for calls to
001180*                         : the main container.
001190*
001200     CALL 'GS' USING SMAILER-1
001210                     SMAILER-2
001220                     SMAILER-3
001230                     SMAILER-4.
001240* -====-
001250 0104-SETTINGS-ROUTINE.
001260     PERFORM WITH TEST AFTER
001270           UNTIL SMAIL002-EVENT-CLOSE-WINDOW
001280           OR SMAIL002-EVENT-CLOSE-AND-STOP
001290           OR SMAIL002-OK
001300*
001310       CALL 'GS' USING SMAIL002-1
001320                       SMAIL002-2
001330                       SMAIL002-3
001340                       SMAIL002-4
001350*
001360*                         : when users presses OK we save
001370*                         : the settins to the registry...
001380*                         : We are not too particular about
001390*                         : the content, as it is fail soft.
001400       EVALUATE TRUE
001410         WHEN SMAIL002-OK
001420           PERFORM 0106-SAVE-SETTINGS
001430       END-EVALUATE
001440*
001450     END-PERFORM.
001460*
001470 0105-FETCH-SETTINGS.
001480     MOVE LOW-VALUES TO
001490         SM-YOUR-EMAIL
001500         SM-SMTP-SERVER
001510         WS-USER-EMAIL-NAME
001520         WS-USER-EMAIL-DOMAIN
001530         WS-USER-EMAIL-AT-SIGN
001540     MOVE 25 TO SM-PORT.
001550*
001560*                         : Upon being initiated, we fetch our
001570*                         : settings from the registry and load
001580*                         : our working storage fields.
001590*                         : First - email address
001600     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001610     MOVE 'Email Address' TO REGISTRY-VALUENAME.
001620     MOVE LOW-VALUES TO REGISTRY-DATA.
001630     SET FUNC-REGISTRY-GET TO TRUE.
001640     PERFORM 0102-API-CALL.
001650     IF NOT WIN32API-FAILED
001660       IF REGISTRY-DATA-LENGTH > ZERO
001670         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001680             TO SM-YOUR-EMAIL.
001690*
001700*                         : Second Smtp server address
001710     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001720     MOVE 'SMTP Server' TO REGISTRY-VALUENAME.
001730     MOVE LOW-VALUES TO REGISTRY-DATA.
001740     SET FUNC-REGISTRY-GET TO TRUE.
001750     PERFORM 0102-API-CALL.
001760     IF NOT WIN32API-FAILED
001770       IF REGISTRY-DATA-LENGTH > ZERO
001780         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001790             TO SM-SMTP-SERVER.
001800*
001810*                         : Fetch the smtp port
001820     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001830     MOVE 'SMTP Port' TO REGISTRY-VALUENAME.
001840     MOVE LOW-VALUES TO REGISTRY-DATA.
001850     SET FUNC-REGISTRY-GET TO TRUE.
001860     PERFORM 0102-API-CALL.
001870     IF NOT WIN32API-FAILED
001880       IF REGISTRY-DATA-LENGTH > ZERO
001890         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001900             TO SM-PORT.
001910*
001920     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001930     MOVE 'User Name' TO REGISTRY-VALUENAME.
001940     MOVE LOW-VALUES TO REGISTRY-DATA.
001950     SET FUNC-REGISTRY-GET TO TRUE.
001960     PERFORM 0102-API-CALL.
001970     IF NOT WIN32API-FAILED
001980       IF REGISTRY-DATA-LENGTH > ZERO
001990         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
002000             TO SM-YOUR-NAME.
002010*
002020     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002030     MOVE 'User LOGIN' TO REGISTRY-VALUENAME.
002040     MOVE LOW-VALUES TO REGISTRY-DATA.
002050     SET FUNC-REGISTRY-GET TO TRUE.
002060     PERFORM 0102-API-CALL.
002070     IF NOT WIN32API-FAILED
002080       IF REGISTRY-DATA-LENGTH > ZERO
002090         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
002100             TO SM-YOUR-LOGIN-NAME.
002110*
002120     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002130     MOVE 'User PASSWD' TO REGISTRY-VALUENAME.
002140     MOVE LOW-VALUES TO REGISTRY-DATA.
002150     SET FUNC-REGISTRY-GET TO TRUE.
002160     PERFORM 0102-API-CALL.
002170     IF NOT WIN32API-FAILED
002180       IF REGISTRY-DATA-LENGTH > ZERO
002190         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
002200             TO SM-YOUR-PASSWORD.
002210*
002220     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002230     MOVE 'Use AUTH' TO REGISTRY-VALUENAME.
002240     MOVE LOW-VALUES TO REGISTRY-DATA.
002250     SET FUNC-REGISTRY-GET TO TRUE.
002260     PERFORM 0102-API-CALL.
002270     IF NOT WIN32API-FAILED
002280       IF REGISTRY-DATA-LENGTH > ZERO
002290         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
002300             TO SM-USE-AUTH.
002310*
002320*                         : break up our address for checking
002330     UNSTRING SM-YOUR-EMAIL DELIMITED '@' INTO
002340         WS-USER-EMAIL-NAME
002350         DELIMITER IN WS-USER-EMAIL-AT-SIGN
002360         WS-USER-EMAIL-DOMAIN.
002370*
002380 0106-SAVE-SETTINGS.
002390*
002400*                         : Upon user settings update we save
002410*                         : settings to the registry.
002420*                         : First - email address
002430     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002440     MOVE 'Email Address' TO REGISTRY-VALUENAME.
002450     MOVE LOW-VALUES TO REGISTRY-DATA.
002460     MOVE 1 TO REGISTRY-DATA-LENGTH
002470     STRING SM-YOUR-EMAIL DELIMITED SPACE
002480          INTO REGISTRY-DATA WITH POINTER REGISTRY-DATA-LENGTH
002490     SET FUNC-REGISTRY-PUT TO TRUE.
002500     PERFORM 0102-API-CALL.
002510*
002520*                         : Second Smtp server address
002530     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002540     MOVE 'SMTP Server' TO REGISTRY-VALUENAME.
002550     MOVE LOW-VALUES TO REGISTRY-DATA.
002560     MOVE 1 TO REGISTRY-DATA-LENGTH
002570     STRING SM-SMTP-SERVER DELIMITED SPACE
002580          INTO REGISTRY-DATA WITH POINTER REGISTRY-DATA-LENGTH
002590     SET FUNC-REGISTRY-PUT TO TRUE.
002600     PERFORM 0102-API-CALL.
002610*
002620*                         : Save the smtp port
002630     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002640     MOVE 'SMTP Port' TO REGISTRY-VALUENAME.
002650     MOVE LOW-VALUES TO REGISTRY-DATA.
002660     MOVE 1 TO REGISTRY-DATA-LENGTH
002670     STRING SM-PORT DELIMITED SIZE INTO REGISTRY-DATA
002680         WITH POINTER REGISTRY-DATA-LENGTH
002690     SET FUNC-REGISTRY-PUT TO TRUE.
002700     PERFORM 0102-API-CALL.
002710*                         : Save the user name
002720     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002730     MOVE 'User Name' TO REGISTRY-VALUENAME.
002740     MOVE LOW-VALUES TO REGISTRY-DATA.
002750     MOVE 1 TO REGISTRY-DATA-LENGTH
002760     STRING SM-YOUR-NAME DELIMITED SIZE INTO REGISTRY-DATA
002770         WITH POINTER REGISTRY-DATA-LENGTH
002780     SET FUNC-REGISTRY-PUT TO TRUE.
002790     PERFORM 0102-API-CALL.
002800*
002810     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002820     MOVE 'User LOGIN' TO REGISTRY-VALUENAME.
002830     MOVE LOW-VALUES TO REGISTRY-DATA.
002840     MOVE 1 TO REGISTRY-DATA-LENGTH
002850     STRING SM-YOUR-LOGIN-NAME DELIMITED SPACE INTO REGISTRY-DATA
002860         WITH POINTER REGISTRY-DATA-LENGTH
002870     SET FUNC-REGISTRY-PUT TO TRUE.
002880     PERFORM 0102-API-CALL.
002890*
002900     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002910     MOVE 'User PASSWD' TO REGISTRY-VALUENAME.
002920     MOVE LOW-VALUES TO REGISTRY-DATA.
002930     MOVE 1 TO REGISTRY-DATA-LENGTH
002940     STRING SM-YOUR-PASSWORD DELIMITED SPACE INTO REGISTRY-DATA
002950         WITH POINTER REGISTRY-DATA-LENGTH
002960     SET FUNC-REGISTRY-PUT TO TRUE.
002970     PERFORM 0102-API-CALL.
002980*
002990     SET REGISTRY-DATA-IS-TEXT TO TRUE.
003000     MOVE 'Use AUTH' TO REGISTRY-VALUENAME.
003010     MOVE LOW-VALUES TO REGISTRY-DATA.
003020     MOVE 1 TO REGISTRY-DATA-LENGTH
003030     STRING SM-USE-AUTH DELIMITED SIZE INTO REGISTRY-DATA
003040         WITH POINTER REGISTRY-DATA-LENGTH
003050     SET FUNC-REGISTRY-PUT TO TRUE.
003060     PERFORM 0102-API-CALL.
003070*                         : Now always read them back again...
003080     PERFORM 0105-FETCH-SETTINGS.
003090*
003100 0107-SEND-MAIL.
003110*                         :---------------------------------------
003120* ------------------------: SENDING A MESSAGE
003130*                         : Here we build a smtp mail message and
003140*                         : send it.
003150*                         : You should be familiar with the
003160*                         : smtp protocol to follow this code. See
003170*                         : http://rfc.sunsite.dk/rfc/rfc2821.html
003180*                         :---------------------------------------
003190*
003200     MOVE SM-YOUR-NAME TO APM-YOUR-NAME
003210     MOVE SM-YOUR-EMAIL TO APM-YOUR-EMAIL
003220     MOVE SM-SMTP-SERVER TO APM-SMTP-SERVER
003230     MOVE SM-PORT TO APM-PORT
003240     MOVE SM-TO-NAME TO APM-TO-NAME
003250     MOVE SM-TO TO APM-TO-EMAIL
003260     MOVE SM-SUBJECT TO APM-SUBJECT
003270     MOVE SM-TEXT TO APM-TEXT
003280     MOVE SPACE TO APM-AUTHENTICATION
003290     IF SM-USE-AUTH-ON
003300       SET APM-AUTHENTICATE-DESIRED TO TRUE
003310       MOVE SM-YOUR-LOGIN-NAME TO
003320           APM-AUTHENTICATION-USERID
003330       MOVE SM-YOUR-PASSWORD TO
003340           APM-AUTHENTICATION-PASSWORD
003350     END-IF
003360*
003370     SET FUNC-SENDMAIL TO TRUE.
003380     CALL 'GSWINAPI' USING WIN32API-PARMS
003390                           APM-MAIL-PARMS
003400                           WIN32API-B
003410                           WIN32API-C
003420                           WIN32API-D
003430                           WIN32API-E
003440                           WIN32API-F.
003450     IF WIN32API-FAILED
003460       MOVE WIN32API-ERROR-TEXT TO SMAIL001-MESSAGE-TEXT
003470       SET SMAIL001-MESSAGE-BAR-BEEP TO TRUE
003480     ELSE
003490       MOVE 'Message Sent.....' TO SMAIL001-MESSAGE-TEXT
003500       SET SMAIL001-MESSAGE-BAR-SILENT TO TRUE.
