000010 IDENTIFICATION DIVISION.
000020*@S              Static Subroutine
000030 PROGRAM-ID. SMAIL0.
000040 DATE-COMPILED.
000050* ------------------------: Configuration handler for end-user
000060*                         : integration of GUI-ScreenIO's Mail API
000070*                         : This program can be compiled and used
000080*                         : to manage the Mailer Configuration
000090*                         : settings.  You must call this routine
000100*                         : any time you want to set or change
000110*                         : the settings for the sample mail
000120*                         : sender (smail1).
000130*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000140 ENVIRONMENT DIVISION.
000150* 080131ja-14 Stand Alone Configure subroutine
000160*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000170 CONFIGURATION SECTION.
000180 SOURCE-COMPUTER. IBM-PC.
000190 OBJECT-COMPUTER. IBM-PC.
000200*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000210 DATA DIVISION.
000220*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000230 WORKING-STORAGE SECTION.
000240 01  V--VERSION-LEVEL                 PIC 9(3) VALUE 14.
000250* -====-
000260         COPY SMAIL002.
000270*                         : Copy values for our API calls
000280         COPY WIN32API.
000290         COPY REGISTRY.
000300         COPY MAILAPI.
000310*
000320*                         : Used to split up email addresses
000330 01  WS-USER-EMAIL-NAME               PIC X(100).
000340 01  WS-USER-EMAIL-DOMAIN             PIC X(100).
000350 01  WS-USER-EMAIL-AT-SIGN            PIC X.
000360*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000370 PROCEDURE DIVISION.
000380*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000390 0100-MAIN-CONTROL SECTION.
000400* -====-
000410 0101-MAIN-LINE-PROCESS.
000420*
000430     PERFORM 0103-FETCH-SETTINGS.
000440     PERFORM WITH TEST AFTER
000450           UNTIL SMAIL002-EVENT-CLOSE-WINDOW
000460           OR SMAIL002-EVENT-CLOSE-AND-STOP
000470           OR SMAIL002-OK
000480*
000490       CALL 'GS' USING SMAIL002-1
000500                       SMAIL002-2
000510                       SMAIL002-3
000520                       SMAIL002-4
000530*
000540*                         : when users presses OK we save
000550*                         : the settins to the registry...
000560*                         : We are not too particular about
000570*                         : the content, as it is fail soft.
000580       EVALUATE TRUE
000590         WHEN SMAIL002-OK
000600           PERFORM 0104-SAVE-SETTINGS
000610       END-EVALUATE
000620*
000630     END-PERFORM.
000640*                         : After the user is done, we go back
000650*                         : to calling program
000660     GOBACK.
000670*
000680 0102-API-CALL.
000690     MOVE 'MailSettings' TO REGISTRY-SUBKEY.
000700     CALL 'GSWINAPI' USING WIN32API-PARMS
000710                           REGISTRY-PARMS
000720                           WIN32API-B
000730                           WIN32API-C
000740                           WIN32API-D
000750                           WIN32API-E
000760                           WIN32API-F.
000770* -====-
000780 0103-FETCH-SETTINGS.
000790     MOVE LOW-VALUES TO
000800         SM-YOUR-EMAIL
000810         SM-SMTP-SERVER
000820         WS-USER-EMAIL-NAME
000830         WS-USER-EMAIL-DOMAIN
000840         WS-USER-EMAIL-AT-SIGN
000850     MOVE 25 TO SM-PORT.
000860*
000870*                         : Upon being initiated, we fetch our
000880*                         : settings from the registry and load
000890*                         : our working storage fields.
000900*                         : First - email address
000910     SET REGISTRY-DATA-IS-TEXT TO TRUE.
000920     MOVE 'Email Address' TO REGISTRY-VALUENAME.
000930     MOVE LOW-VALUES TO REGISTRY-DATA.
000940     SET FUNC-REGISTRY-GET TO TRUE.
000950     PERFORM 0102-API-CALL.
000960     IF NOT WIN32API-FAILED
000970       IF REGISTRY-DATA-LENGTH > ZERO
000980         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
000990             TO SM-YOUR-EMAIL.
001000*
001010*                         : Second Smtp server address
001020     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001030     MOVE 'SMTP Server' TO REGISTRY-VALUENAME.
001040     MOVE LOW-VALUES TO REGISTRY-DATA.
001050     SET FUNC-REGISTRY-GET TO TRUE.
001060     PERFORM 0102-API-CALL.
001070     IF NOT WIN32API-FAILED
001080       IF REGISTRY-DATA-LENGTH > ZERO
001090         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001100             TO SM-SMTP-SERVER.
001110*
001120*                         : Fetch the smtp port
001130     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001140     MOVE 'SMTP Port' TO REGISTRY-VALUENAME.
001150     MOVE LOW-VALUES TO REGISTRY-DATA.
001160     SET FUNC-REGISTRY-GET TO TRUE.
001170     PERFORM 0102-API-CALL.
001180     IF NOT WIN32API-FAILED
001190       IF REGISTRY-DATA-LENGTH > ZERO
001200         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001210             TO SM-PORT.
001220*
001230     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001240     MOVE 'User Name' TO REGISTRY-VALUENAME.
001250     MOVE LOW-VALUES TO REGISTRY-DATA.
001260     SET FUNC-REGISTRY-GET TO TRUE.
001270     PERFORM 0102-API-CALL.
001280     IF NOT WIN32API-FAILED
001290       IF REGISTRY-DATA-LENGTH > ZERO
001300         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001310             TO SM-YOUR-NAME.
001320*
001330     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001340     MOVE 'User LOGIN' TO REGISTRY-VALUENAME.
001350     MOVE LOW-VALUES TO REGISTRY-DATA.
001360     SET FUNC-REGISTRY-GET TO TRUE.
001370     PERFORM 0102-API-CALL.
001380     IF NOT WIN32API-FAILED
001390       IF REGISTRY-DATA-LENGTH > ZERO
001400         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001410             TO SM-YOUR-LOGIN-NAME.
001420*
001430     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001440     MOVE 'User PASSWD' TO REGISTRY-VALUENAME.
001450     MOVE LOW-VALUES TO REGISTRY-DATA.
001460     SET FUNC-REGISTRY-GET TO TRUE.
001470     PERFORM 0102-API-CALL.
001480     IF NOT WIN32API-FAILED
001490       IF REGISTRY-DATA-LENGTH > ZERO
001500         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001510             TO SM-YOUR-PASSWORD.
001520*
001530     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001540     MOVE 'Use AUTH' TO REGISTRY-VALUENAME.
001550     MOVE LOW-VALUES TO REGISTRY-DATA.
001560     SET FUNC-REGISTRY-GET TO TRUE.
001570     PERFORM 0102-API-CALL.
001580     IF NOT WIN32API-FAILED
001590       IF REGISTRY-DATA-LENGTH > ZERO
001600         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001610             TO SM-USE-AUTH.
001620*
001630*                         : break up our address for checking
001640     UNSTRING SM-YOUR-EMAIL DELIMITED '@' INTO
001650         WS-USER-EMAIL-NAME
001660         DELIMITER IN WS-USER-EMAIL-AT-SIGN
001670         WS-USER-EMAIL-DOMAIN.
001680*
001690 0104-SAVE-SETTINGS.
001700*
001710*                         : Upon user settings update we save
001720*                         : settings to the registry.
001730*                         : First - email address
001740     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001750     MOVE 'Email Address' TO REGISTRY-VALUENAME.
001760     MOVE LOW-VALUES TO REGISTRY-DATA.
001770     MOVE 1 TO REGISTRY-DATA-LENGTH
001780     STRING SM-YOUR-EMAIL DELIMITED SPACE
001790          INTO REGISTRY-DATA WITH POINTER REGISTRY-DATA-LENGTH
001800     SET FUNC-REGISTRY-PUT TO TRUE.
001810     PERFORM 0102-API-CALL.
001820*
001830*                         : Second Smtp server address
001840     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001850     MOVE 'SMTP Server' TO REGISTRY-VALUENAME.
001860     MOVE LOW-VALUES TO REGISTRY-DATA.
001870     MOVE 1 TO REGISTRY-DATA-LENGTH
001880     STRING SM-SMTP-SERVER DELIMITED SPACE
001890          INTO REGISTRY-DATA WITH POINTER REGISTRY-DATA-LENGTH
001900     SET FUNC-REGISTRY-PUT TO TRUE.
001910     PERFORM 0102-API-CALL.
001920*
001930*                         : Save the smtp port
001940     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001950     MOVE 'SMTP Port' TO REGISTRY-VALUENAME.
001960     MOVE LOW-VALUES TO REGISTRY-DATA.
001970     MOVE 1 TO REGISTRY-DATA-LENGTH
001980     STRING SM-PORT DELIMITED SIZE INTO REGISTRY-DATA
001990         WITH POINTER REGISTRY-DATA-LENGTH
002000     SET FUNC-REGISTRY-PUT TO TRUE.
002010     PERFORM 0102-API-CALL.
002020*                         : Save the user name
002030     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002040     MOVE 'User Name' TO REGISTRY-VALUENAME.
002050     MOVE LOW-VALUES TO REGISTRY-DATA.
002060     MOVE 1 TO REGISTRY-DATA-LENGTH
002070     STRING SM-YOUR-NAME DELIMITED SIZE INTO REGISTRY-DATA
002080         WITH POINTER REGISTRY-DATA-LENGTH
002090     SET FUNC-REGISTRY-PUT TO TRUE.
002100     PERFORM 0102-API-CALL.
002110*
002120     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002130     MOVE 'User LOGIN' TO REGISTRY-VALUENAME.
002140     MOVE LOW-VALUES TO REGISTRY-DATA.
002150     MOVE 1 TO REGISTRY-DATA-LENGTH
002160     STRING SM-YOUR-LOGIN-NAME DELIMITED SPACE INTO REGISTRY-DATA
002170         WITH POINTER REGISTRY-DATA-LENGTH
002180     SET FUNC-REGISTRY-PUT TO TRUE.
002190     PERFORM 0102-API-CALL.
002200*
002210     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002220     MOVE 'User PASSWD' TO REGISTRY-VALUENAME.
002230     MOVE LOW-VALUES TO REGISTRY-DATA.
002240     MOVE 1 TO REGISTRY-DATA-LENGTH
002250     STRING SM-YOUR-PASSWORD DELIMITED SPACE INTO REGISTRY-DATA
002260         WITH POINTER REGISTRY-DATA-LENGTH
002270     SET FUNC-REGISTRY-PUT TO TRUE.
002280     PERFORM 0102-API-CALL.
002290*
002300     SET REGISTRY-DATA-IS-TEXT TO TRUE.
002310     MOVE 'Use AUTH' TO REGISTRY-VALUENAME.
002320     MOVE LOW-VALUES TO REGISTRY-DATA.
002330     MOVE 1 TO REGISTRY-DATA-LENGTH
002340     STRING SM-USE-AUTH DELIMITED SIZE INTO REGISTRY-DATA
002350         WITH POINTER REGISTRY-DATA-LENGTH
002360     SET FUNC-REGISTRY-PUT TO TRUE.
002370     PERFORM 0102-API-CALL.
002380*                         : Now always read them back again...
002390     PERFORM 0103-FETCH-SETTINGS.
002400*
